#[derive(Debug)]
pub enum Error {
    AlreadyConnected,
    Presence(Reason),
    Roster(Reason),
    SendMessage(Reason),
    AlreadyDisconnected,
    LostConnection,
}

#[derive(Debug)]
pub enum Reason {
    // TODO: organisastion of error into internal error thing
    Timeout,
    Stream(stanza::stream_error::Error),
    Stanza(stanza::stanza_error::Error),
    Jabber(jabber::Error),
    XML(peanuts::Error),
    SQL(sqlx::Error),
    // JID(jid::ParseError),
    LostConnection,
}

impl From<peanuts::Error> for Error {
    fn from(e: peanuts::Error) -> Self {
        Self::XML(e)
    }
}

// impl From<jid::ParseError> for Error {
//     fn from(e: jid::ParseError) -> Self {
//         Self::JID(e)
//     }
// }

impl From<sqlx::Error> for Error {
    fn from(e: sqlx::Error) -> Self {
        Self::SQL(e)
    }
}

impl From<jabber::Error> for Error {
    fn from(e: jabber::Error) -> Self {
        Self::Jabber(e)
    }
}
