use std::collections::HashSet;

use jid::JID;
use uuid::Uuid;

use crate::user::User;

#[derive(Debug)]
pub struct Contact {
    // jid is the id used to reference everything, but not the primary key
    user: User,
    jid: JID,
    subscription: Subscription,
    /// client user defined name
    name: Option<String>,
    // TODO: avatar, nickname
    /// nickname picked by contact
    // nickname: Option<String>,
    groups: HashSet<String>,
}

#[derive(Debug)]
enum Subscription {
    None,
    PendingOut,
    PendingIn,
    OnlyOut,
    OnlyIn,
    OutPendingIn,
    InPendingOut,
    Buddy,
}
